<?php

namespace Teknisa\SUP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;

class ParametrosParaImportacaoDeAFService {
    
    protected $connection;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    
    
    public function insertConfirmarParametros ($row){
        
        /*$query = "DELETE FROM USR_PARAMINTEGRA WHERE CDFORNECED = :P_CDFORNECED";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
        
        self.insertConfirmarParametros($row);*/

		$param = array();
        $param['P_CDFORNECED'] = $row['CDFORNECED'];
        $query = "INSERT INTO USR_PARAMINTEGRA(CDFORNECED, DSHOST, DSLOGIN, DSSENHA, CDOPERADOR, VRINTERVALO) VALUES (:P_CDFORNECED, :P_HOST, :P_LOGIN, :P_SENHA, :P_CDOPERADOR, :P_VRINTERVALO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqFornParamImpAf($CDFORNECED){
		$param = array();
        $param['P_FORNECED'] = $CDFORNECED;
        $query =    "SELECT 'S' AS CDPARAMINT, CDFORNECED, CDOPERADOR, DSDIRENVIO, DSHOST, DSLOGIN, DSSENHA, VRINTERVALO
                    FROM USR_PARAMINTEGRA 
                    WHERE CDFORNECED = :P_FORNECED OR :P_FORNECED = 'T'";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqAutoForne_USR($USR_NRIMPORTAF, $CDFORNECED){
        $param = array();
        $param['P_USR_NRIMPORTAF'] = $USR_NRIMPORTAF;
        $param['P_CDFORNECED'] = $CDFORNECED;
        $query =    "SELECT USR_NRIMPORTAF, CDFILDEST, CDFILLANC, NRAUTOFORN
                    FROM AUTOFORNE
                    WHERE USR_NRIMPORTAF = :P_USR_NRIMPORTAF
                    AND CDFORNECED     = :P_CDFORNECED";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqFilDest($CDFILIAL){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILIAL;
        $query =    "SELECT CDFILIAL, NMFILIAL, NVL(CDFILCENTCMP, CDFILIAL)  CDFILCENTCMP, CDREGIAO
                    FROM FILIAL
                    WHERE CDFILIAL = :P_CDFILDEST";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqFornecedor($CDFORNECED){
        $param = array();
        $param['P_CDFORNECED'] = $CDFORNECED;
        $query =    "SELECT CDFORMPGTO, IDTPFORPGTFO, NMFANTFORN, NRPARCPGTOFO, NRDIAPGFIXFO, IDUTDIAPGTFO
                    FROM FORNECEDOR
                    WHERE CDFORNECED = :P_CDFORNECED";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqAutoForne($CDFILDEST, $CDFILLANC, $NRAUTOFORN){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $query =    "SELECT NRAUTOFORN, CDFILDEST, CDFILLANC
                    FROM AUTOFORNE
                    WHERE CDFILDEST   = :P_CDFILDEST
                    AND CDFILLANC   = :P_CDFILLANC
                    AND NRAUTOFORN  = :P_NRAUTOFORN";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmInsAutoForne($CDFILDEST, $CDFILLANC, $NRAUTOFORN, $CDFORNECED, $CDOPERADOR, $CDFORMPGTO, $IDTPFORPGTAF, $CDEMPRESA, $NRPARCPGTOAF, $NRDIAPGFIXAF, $IDUTDIAPGTAF){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $param['P_CDOPERADOR'] = $CDOPERADOR;
        $param['P_CDFORNECED'] = $CDFORNECED;
        $param['P_CDFORMPGTO'] = $CDFORMPGTO;
        $param['P_IDTPFORPGTAF'] = $IDTPFORPGTAF;
        $param['P_CDEMPRESA'] = $CDEMPRESA;
        $param['P_NRPARCPGTOAF'] = $NRPARCPGTOAF;
        $param['P_NRDIAPGFIXAF'] = $NRDIAPGFIXAF;
        $param['P_IDUTDIAPGTAF'] = $IDUTDIAPGTAF;
        $query =    "INSERT into AUTOFORNE
                    (CDFILDEST, CDFILLANC, NRAUTOFORN, CDFORNECED, DTAUTOFORN, CDOPERADOR, CDFORMPGTO, IDTPFORPGTAF, IDTIPOEMITAF, CDEMPRESA,
                    NRPARCPGTOAF, NRDIAPGFIXAF, IDUTDIAPGTAF)
                    VALUES
                    (:P_CDFILDEST, :P_CDFILLANC, :P_NRAUTOFORN, :P_CDFORNECED,  TRUNC(SYSDATE),
                    :P_CDOPERADOR, :P_CDFORMPGTO, :P_IDTPFORPGTAF, '1', :P_CDEMPRESA,
                    :P_NRPARCPGTOAF, :P_NRDIAPGFIXAF, :P_IDUTDIAPGTAF)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmInsPrazoPgtAF($CDFILDEST, $CDFILLANC, $NRAUTOFORN, $CDFORNECED){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $param['P_CDFORNECED'] = $CDFORNECED;
        $query =    "INSERT INTO PRAZOPGTAF (CDFILDEST, CDFILLANC, NRAUTOFORN, NRDIASPGTOAF, VRPERCPGTOAF)
                    (SELECT :P_CDFILDEST, :P_CDFILLANC, :P_NRAUTOFORN, NRDIASPGTOFO, VRPERCPGTOFO
                    FROM PRAZOPGTFORN
                    WHERE CDFORNECED = :P_CDFORNECED)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqProduto($CDPRODUTO){
        $param = array();
        $param['P_CDPRODUTO'] = $CDPRODUTO;
        $query =    "SELECT CDPRODUTO, CDARVPROD, NMPRODUTO 
                    FROM PRODUTO
                    WHERE CDPRODUTO = :P_CDPRODUTO";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqProdForn($CDFORNECED, $CDPRODUTO){
        $param = array();
        $param['P_CDFORNECED'] = $CDFORNECED;
        $param['P_CDPRODUTO'] = $CDPRODUTO;
        $query =    "SELECT MAX(CDPRODCOMPL) CDPRODCOMPL
                    FROM PRODFORNCOMP
                    WHERE CDFORNECED = :P_CDFORNECED
                    AND :P_CDPRODUTO LIKE CDPRODUTO||'%'";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function adqMelhorPreco($CDCENTCMP, $CDFORNECED, $CDFILDEST, $DTPROGENTAF, $CDPRODUTO/*, $CDMARCA*/){
        $param = array();
        $param['P_CDCENTCMP'] = $CDCENTCMP;
        $param['P_CDFORNECED'] = $CDFORNECED;
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_DTPROGENTAF'] = $DTPROGENTAF;
        $param['P_CDPRODUTO'] = $CDPRODUTO;
        $query =    "SELECT FILIAL.CDFILIAL, NVL(ITEMCOLE.VRPRECUNIITM, 0) VRPRECUNIITM
                    FROM ITEMCOLE, FILIAL, PRODUTO
                    WHERE ITEMCOLE.CDFILIAL     = :P_CDCENTCMP
                    AND ITEMCOLE.CDFORNECED   = :P_CDFORNECED
                    AND FILIAL.CDFILIAL       = :P_CDFILDEST
                    AND PRODUTO.CDPRODUTO     = :P_CDPRODUTO
                    AND ITEMCOLE.CDREGIAO     = FILIAL.CDREGIAO
                    AND ITEMCOLE.CDPRODUTO    =  PRODUTO.CDPRODUTO
                    --AND ITEMCOLE.CDMARCA      = :P_CDMARCA
                    AND NVL(ITEMCOLE.VRPRECUNIITM, 0)  > 0
                    AND :P_DTPROGENTAF BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmInsPrazoPgtAF($CDFILDEST, $CDFILLANC, $NRAUTOFORN, $CDPRODUTO, $DTPROGENTAF, $CDMARCA){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $param['P_CDPRODUTO'] = $CDPRODUTO;
        $param['P_DTPROGENTAF'] = $DTPROGENTAF;
        $param['P_CDMARCA'] = $CDMARCA;
        $query =    "insert into ITEMAUTF
                    (CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, QTPROGENTAF,
                    VRPREUNIAF, DTPROGENTAF, CDMARCA)
                    SELECT :P_CDFILDEST, :P_CDFILLANC, :P_NRAUTOFORN, :P_CDPRODUTO, :P_QTPROGENTAF,
                       :P_VRPREUNIAF, :P_DTPROGENTAF, :P_CDMARCA
                    FROM DUAL
                    WHERE NOT EXISTS(SELECT 1
                                    FROM ITEMAUTF I
                                   WHERE I.CDFILDEST    = :P_CDFILDEST
                                     AND I.CDFILLANC    = :P_CDFILLANC
                                     AND I.NRAUTOFORN   = :P_NRAUTOFORN
                                     AND I.CDPRODUTO    = :P_CDPRODUTO
                                     AND I.DTPROGENTAF  = :P_DTPROGENTAF
                                     AND I.CDMARCA      = :P_CDMARCA)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmInsMensAutF($NRMENSAUTFOR, $CDFILLANC, $NRAUTOFORN, $DSMENSAF, $CDFILDEST){
        $param = array();
        $param['P_NRMENSAUTFOR'] = $NRMENSAUTFOR;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $param['P_DSMENSAF'] = $DSMENSAF;
        $param['P_CDFILDEST'] = $CDFILDEST;
        $query =    "INSERT INTO MENSAUTF
                    (NRMENSAUTFOR, CDFILLANC, NRAUTOFORN, DSMENSAF, CDFILDEST)
                    VALUES (:P_NRMENSAUTFOR, :P_CDFILLANC, :P_NRAUTOFORN, :P_DSMENSAF, :P_CDFILDEST)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmUpdAutoForne($USR_NRIMPORTAF, $CDFILDEST, $CDFILLANC, $NRAUTOFORN){
        $param = array();
        $param['P_USR_NRIMPORTAF'] = $USR_NRIMPORTAF;
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $query =    "UPDATE AUTOFORNE
                    SET USR_NRIMPORTAF = :P_USR_NRIMPORTAF
                    WHERE CDFILDEST       = :P_CDFILDEST
                    AND CDFILLANC       = :P_CDFILLANC
                    AND NRAUTOFORN      = :P_NRAUTOFORN";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmDelAutoforn($CDFILDEST, $CDFILLANC, $NRAUTOFORN){
        $param = array();
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDFILLANC'] = $CDFILLANC;
        $param['P_NRAUTOFORN'] = $NRAUTOFORN;
        $query =    "DELETE FROM AUTOFORNE
                    WHERE CDFILDEST       = :P_CDFILDEST
                    AND CDFILLANC       = :P_CDFILLANC
                    AND NRAUTOFORN      = :P_NRAUTOFORN";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmLogImpItemautf($USR_NRIMPORTAF, $CDFILDEST, $CDPRODUTO, $DTPROGENTAF, $DSERROIMPORTAF){
        $param = array();
        $param['P_USR_NRIMPORTAF'] = $USR_NRIMPORTAF;
        $param['P_CDFILDEST'] = $CDFILDEST;
        $param['P_CDPRODUTO'] = $CDPRODUTO;
        $param['P_DTPROGENTAF'] = $DTPROGENTAF;
        $param['P_DSERROIMPORTAF'] = $DSERROIMPORTAF;
        $query =    "INSERT INTO LOGIMPITEMAUTF (USR_NRIMPORTAF, CDFILDEST, CDPRODUTO, DTPROGENTAF, DTIMPITEMAUTF, DSERROIMPORTAF)
                    VALUES (:P_USR_NRIMPORTAF, :P_CDFILDEST, :P_CDPRODUTO, :P_DTPROGENTAF, SYSDATE, :P_DSERROIMPORTAF)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmDelParamImportAF($CDFORNECED){
        $param = array();
        $param['P_CDFORNECED'] = $CDFORNECED;
        $query =    "DELETE FROM USR_PARAMINTEGRA
                    WHERE CDFORNECED = :P_CDFORNECED ";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function acmInsParamImportAF($CDFORNECED, $DSDIRENVIO, $HOST, $LOGIN, $SENHA, $CDOPERADOR, $VRINTERVALO){
        $param = array();
        $param['P_CDFORNECED'] = $CDFORNECED;
        $param['P_DSDIRENVIO'] = $DSDIRENVIO;
        $param['P_HOST'] = $HOST;
        $param['P_LOGIN'] = $LOGIN;
        $param['P_SENHA'] = $SENHA;
        $param['P_CDOPERADOR'] = $CDOPERADOR;
        $param['P_VRINTERVALO'] = $VRINTERVALO;
        $query =    "INSERT INTO USR_PARAMINTEGRA(CDFORNECED, DSDIRENVIO, DSHOST, DSLOGIN,
                    DSSENHA, CDOPERADOR, VRINTERVALO)
                    VALUES (:P_CDFORNECED, :P_DSDIRENVIO, :P_HOST, :P_LOGIN,
                    :P_SENHA, :P_CDOPERADOR, :P_VRINTERVALO)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }
    }
}